<template>
  <div class="page">
    <div
      class="back-link"
      @click="$router.push({ name: 'Groups' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Groupes d'utilisateurs
      </span>
    </div>
    <b-overlay
      v-if="loading"
      id="overlay-background"
      :show="loading"
      :variant="'white'"
      :opacity="0.7"
      :blur="'2px'"
      rounded="sm"
      style="min-height: 30em;"
    >
    </b-overlay>
    <b-container v-else fluid>
      <b-row>
        <b-col
          cols="8"
          class="detail-forms"
        >
          <h1>{{ currentUsergroup.display_name }}</h1>
          <GroupForm
            :group="currentUsergroup"
            @save="updateGroup"
          />
        </b-col>
        <b-col
          cols="4"
          class="detail-card"
        >
          <GroupCard
            :group="currentUsergroup"
          />
        </b-col>
      </b-row>
      <b-row style="height: auto;">
        <b-col
          cols="11"
          class="users-table"
        >
          <h3 class="line-header">
            <img
              src="@/assets/icons/face_user.svg"
              alt="Icône silhouette utilisateur"
            /> Utilisateurs
          </h3>
          <h5 style="margin-left: 1em;">
            Ajouter un utilisateur au groupe {{ currentUsergroup.display_name }}
          </h5>
          <p style="margin: 0 0 0 1.2em; font-size: 1em;">
            Saisissez les premiers caractères d'un utilisateur pour lancer une recherche.
          </p>
          <form style="margin-top: 0;">
            <div
              class="form-row"
              style="align-items: flex-end; margin-left: -1.2em;"
            >
              <div class="form-group col-4">
                <SearchUsers
                  :resetAfter="false"
                  placeholder="Rechercher un utilisateur ..."
                  @select="setSelectedUser"
                />
              </div>
              <div
                class="form-group col-3"
                :class="{disabled: !selectedUser.user}"
              >
                <Multiselect
                  v-model="selectedUser.role"
                  :options="usergroupsRoles"
                  track-by="choice"
                  label="label"
                  selectLabel=""
                  selectedLabel=""
                  deselectLabel=""
                  :searchable="false"
                  placeholder="Rôle"
                  @input="handleBlur"
                />
              </div>
              <div
                class="form-group col-3"
                :class="{disabled: !selectedUser.role}"
              >
                <Multiselect
                  v-model="selectedUser.status"
                  :options="statusOptions"
                  track-by="choice"
                  label="label"
                  selectLabel=""
                  selectedLabel=""
                  deselectLabel=""
                  :searchable="false"
                  placeholder="Statut"
                  @input="handleBlur"
                />
              </div>
              <div class="form-group col-2">
                <b-button
                  variant="success"
                  :disabled="!allowAdd"
                  @click.prevent="addUserToGroup"
                >
                  Valider
                </b-button>
              </div>
            </div>
          </form>
          <h5 style="margin-left: 1em;">
            Utilisateurs membres du groupe {{ currentUsergroup.display_name }}
          </h5>
          <b-overlay
            :show="loadingTable"
            :variant="'white'"
            :opacity="0.9"
            :blur="'2px'"
            rounded="sm"
          >
            <CustomTable
              :fields="membersFields"
              :items="membersItems"
              :routeTo="'UserDetail'"
              :defaultSorting="{
                sortedUp: true,
                sortedDown: false,
                sortedField: 'user__last_name'
              }"
              :sortFunction="GET_USERGROUP_MEMBERS"
              @sorted="setMembersTableSorted"
              @delete="openRemoveModal"
              @loading="setTableLoader"
            />
            <Pagination
              :nbPages="Math.ceil(currentUsergroupMembersCount/50)"
              @change-page="changeTablePage"
            />
          </b-overlay>
        </b-col>
      </b-row>
    </b-container>
    <RemoveFromGroup
      :open="removingUser"
      :user="userToRemove"
      @hide="removingUser = false"
      @remove="removeUserFromGroup"
    />
  </div>
</template>

<script>
import Multiselect from 'vue-multiselect';
import GroupForm from '@/components/Forms/GroupForm.vue';
import GroupCard from '@/components/Cards/GroupCard.vue';
import SearchUsers from '@/components/SearchUsers.vue';
import CustomTable from '@/components/CustomTable.vue';
import Pagination from '@/components/Pagination.vue';
import RemoveFromGroup from '@/components/Modals/RemoveFromGroup.vue';

import { mapState, mapActions } from 'vuex';

export default {
  name: 'GroupDetail',

  components: {
    Multiselect,
    GroupForm,
    GroupCard,
    SearchUsers,
    CustomTable,
    Pagination,
    RemoveFromGroup
  },

  data() {
    return {
      loading: false,
      loadingTable: false,
      membersFields: [
        {
          key: 'Nom',
          apiName: 'user__last_name',
          sortable: true,
          width: '',
          centered: false
        },
        {
          key: 'Prénom',
          apiName: 'user__first_name',
          sortable: true,
          width: '10%',
          centered: false
        },
        {
          key: 'Identifiant',
          apiName: 'user__username',
          sortable: true,
          width: '10%',
          centered: false
        },
        {
          key: 'Rôle',
          apiName: 'role',
          sortable: true,
          width: '8%',
          centered: false
        },
        {
          key: 'Date d\'inscription',
          apiName: 'date_joined',
          sortable: true,
          width: '15%',
          centered: true
        },
        {
          key: 'Dernière connexion',
          apiName: 'user__last_login',
          sortable: true,
          width: '15%',
          centered: true
        },
        {
          key: 'Statut',
          apiName: 'status',
          sortable: true,
          width: '9%',
          centered: true
        },
        {
          key: 'Admin',
          apiName: 'is_superuser',
          sortable: false,
          width: '7%',
          centered: true
        },
        {
          key: 'Retirer de l\'organisation',
          sortable: false,
          width: '17%',
          centered: true
        }
      ],
      membersTableSorted: {
        direction: '-',
        field: 'date_joined'
      },
      removingUser: false,
      userToRemove: null,
      selectedUser: {
        user: null,
        role: null,
        status: null
      },
      statusOptions: [
        {
          choice: 0,
          label: 'Attente de vérification'
        },
        {
          choice: 1,
          label: 'Attente de validation'
        },
        {
          choice: 2,
          label: 'Actif'
        }
      ],
      allowAdd: false
    };
  },

  computed: {
    ...mapState('usergroups', [
      'currentUsergroup',
      'currentUsergroupMembers',
      'currentUsergroupMembersCount',
      'currentUsergroupChildren',
      'usergroupsRoles'
    ]),
    membersItems() {
      return this.currentUsergroupMembers.map(el => {
        return {
          id: el.user.id,
          'Nom': el.user.last_name,
          'Prénom': el.user.first_name,
          'Identifiant': el.user.username,
          'Rôle':
            this.usergroupsRoles.find(item => item.choice === el.role) ? this.usergroupsRoles.find(item => item.choice === el.role).label : '',
          'Date d\'inscription': new Date(el.date_joined).toLocaleString('fr-FR', {year: "numeric", month: "long", day: "numeric"}),
          'Dernière connexion': new Date(el.user.last_login).toLocaleString('fr-FR', {year: "numeric", month: "long", day: "numeric"}),
          'Statut': [
            {choice: 0, value: 'secondary'},
            {choice: 1, value: 'warning'},
            {choice: 2, value: 'success'}
          ].find(item => item.choice === el.status).value,
          'Admin': el.user.is_superuser ? el.user.is_superuser : false
        }
      });
    }
  },

  created() {
    this.loading = true;
    if (this.usergroupsRoles.length === 0) {
      this.GET_USERGROUPS_ROLES();
    }
    Promise.all([
      this.GET_USERGROUP_DETAIL(this.$route.params.id),
      this.GET_USERGROUP_MEMBERS({
        id: this.$route.params.id,
        ...this.membersTableSorted
      })
    ]).then(() => {
      this.loading = false;
    });
  },

  mounted() {
    // Watch modal closing event
    this.$root.$on('bv::modal::hide', () => {
      this.removingUser = false
    });
  },

  methods: {
    ...mapActions('usergroups', [
      'GET_USERGROUP_DETAIL',
      'GET_USERGROUP_MEMBERS',
      'GET_USERGROUP_CHILDREN',
      'GET_USERGROUPS_GROUPS_LIST',
      'GET_USERGROUPS_ROLES',
      'UPDATE_USERGROUP'
    ]),
    ...mapActions('users', [
      'GET_USERS_LIST',
      'ADD_USER_ROLE',
      'REMOVE_USER_ROLE'
    ]),

    setSelectedUser(e) {
      this.selectedUser.user = e;
    },

    addUserToGroup() {
      this.loading = true;
      const data = {
        role: this.selectedUser.role.choice,
        status: this.selectedUser.status.choice,
        user: { id: this.selectedUser.user.id },
      };
      this.ADD_USER_ROLE({
        usergroup: this.currentUsergroup,
        data: data,
        type:'group'
      })
        .then(() => {
          Promise.all([
            this.GET_USERGROUP_DETAIL(this.$route.params.id),
            this.GET_USERGROUP_MEMBERS({
              id: this.$route.params.id,
              ...this.childrenTableSorted
            })
          ]).then(() => {
            this.loading = false;
          });
        });
    },

    handleBlur() {
      if (this.selectedUser.organisation !== null && this.selectedUser.role !== null && this.selectedUser.status !== null) {
        this.allowAdd = true;
      } else {
        this.allowAdd = false;
      }
    },

    updateGroup(e) {
      this.loading = true;
      this.UPDATE_USERGROUP({
        id: this.currentUsergroup.id,
        data: e
      }).then(() => {
        Promise.all([
          this.GET_USERGROUP_DETAIL(this.$route.params.id),
          this.GET_USERGROUPS_GROUPS_LIST({
            direction: null,
            field: null
          }),
        ]).then(() => {
          this.loading = false;
        });
      });
    },

    changeTablePage() {
      this.setTableLoader(true);
      this.GET_USERGROUP_MEMBERS({
        id: this.$route.params.id,
        ...this.childrenTableSorted
      })
        .then(() => {
          this.setTableLoader(false);
        })
        .catch((err) => {
          console.error(err);
          this.setTableLoader(false);
        });
    },

    setTableLoader(e) {
      this.loadingTable = e;
    },

    setMembersTableSorted(e) {
      this.membersTableSorted = e;
    },

    openRemoveModal(e) {
      this.removingUser = true;
      this.userToRemove = e;
    },

    removeUserFromGroup(e) {
      const user = this.currentUsergroupMembers.find(el => el.user.id === e.id);
      this.loading = true;
      this.REMOVE_USER_ROLE({
        usergroup: this.currentUsergroup,
        userId: user.id,
        type: 'group'
      })
        .then(() => {
          Promise.all([
            this.GET_USERGROUP_DETAIL(this.$route.params.id),
            this.GET_USERGROUP_MEMBERS({
              id: this.$route.params.id,
              ...this.childrenTableSorted
            }),
            this.GET_USERS_LIST({
              direction: null,
              field: null
            })
          ])
          .then(() => {
            this.loading = false;
          });
        });
    }
  }
}
</script>

<style lang="less" scoped>

.container-fluid {
  margin: 1em;
  padding-bottom: 3em;
  height: fit-content;
  .row {
    height: fit-content;
  }
}

p {
  width: 100%;
  color: grey;
  font-style: italic;
  font-size: 0.7em;
  margin-bottom: 0.2em;
}

</style>
